﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace BaseApplicationProject
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var datasource = new List<IDiskItem>() {
           new Folder("Windows", 
               new List<IDiskItem>() {
                    new Folder("Fonts", new List<IDiskItem>() { new File("Arial", 256), new File("Tahoma", 246)}),
                    new Folder("Logs", new List<IDiskItem>() { new File("Log1.log", 112), new File("Log2.log", 156)})
               }),
               new Folder ("My Documents", new List<IDiskItem>() {
                   new File("Document1.txt", 88), new File("Document2.txt", 55)}),
               new File("pagefile.sys", 114)};
            treeMap1.ItemsSource = datasource;
        }
    }

    public interface IDiskItem
    {
        string Name { get; }
        long Size { get; }
        IEnumerable<IDiskItem> Children { get; }
    }
    public class Folder : IDiskItem
    {
        private string _name;
        private IEnumerable<IDiskItem> _children;

        public Folder(string name, IEnumerable<IDiskItem> children)
        {
            this._name = name;
            this._children = children;
        }

        public string Name
        {
            get
            {
                return _name;
            }
        }

        public long Size
        {
            get
            {
                return this.Children.Sum(child => child.Size);
            }
        }

        public IEnumerable<IDiskItem> Children
        {
            get
            {
                return _children;
            }
        }
    }

    public class File : IDiskItem
    {
        private string _name;
        private long _size;

        public File(string name, long size)
        {
            this._name = name;
            this._size = size;
        }

        public string Name
        {
            get
            {
                return _name;
            }
        }

        public long Size
        {
            get
            {
                return _size;
            }
        }

        public IEnumerable<IDiskItem> Children
        {
            get { return null; }
        }
    }

}
